SystemOrganization addCategory: #ZipperControl!
SystemOrganization addCategory: #'ZipperControl-Tests'!

Object subclass: #Maybe
	instanceVariableNames: ''
	classVariableNames: 'NothingSingleton'
	poolDictionaries: ''
	category: 'ZipperControl'!

Maybe subclass: #Just
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl'!

!Just class methodsFor: 'private' stamp: 'fbs 6/14/2011 18:09'!
value: anObject
	^ self new value: anObject.! !

!Just methodsFor: 'testing' stamp: 'fbs 6/15/2011 17:24'!
hasValue
	^ true.! !

!Just methodsFor: 'running' stamp: 'fbs 6/15/2011 17:56'!
maybe: aBlock default: anObject
	^ aBlock value: value.! !

!Just methodsFor: 'printing' stamp: 'fbs 6/15/2011 17:42'!
printOn: aStream
	aStream nextPutAll: 'Just '.
	^ value printOn: aStream.! !

!Just methodsFor: 'accessing' stamp: 'fbs 6/14/2011 18:09'!
value
	^ value! !

!Just methodsFor: 'private' stamp: 'fbs 6/14/2011 18:10'!
value: anObject
	value := anObject.! !

!Maybe class methodsFor: 'class initialization' stamp: 'fbs 6/14/2011 18:38'!
initialize
	^ NothingSingleton ifNil: [NothingSingleton := Nothing new]! !

!Maybe class methodsFor: 'instance creation' stamp: 'fbs 6/14/2011 18:38'!
nothing
	^ NothingSingleton! !

!Maybe class methodsFor: 'instance creation' stamp: 'fbs 6/14/2011 18:09'!
value: anObject
	^ Just value: anObject.! !

!Maybe methodsFor: 'testing' stamp: 'fbs 6/15/2011 17:24'!
hasValue
	^ false.! !

!Maybe methodsFor: 'testing' stamp: 'fbs 6/15/2011 17:31'!
ifNothing: nothingBlock ifNotNothing: justBlock
	^ self hasValue
		ifTrue: [justBlock value]
		ifFalse: [nothingBlock value]! !

!Maybe methodsFor: 'accessing' stamp: 'fbs 6/14/2011 18:10'!
value
	self subclassResponsibility! !

Maybe subclass: #Nothing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl'!

!Nothing methodsFor: 'running' stamp: 'fbs 6/15/2011 17:55'!
maybe: aBlock default: anObject
	^ anObject.! !

!Nothing methodsFor: 'printing' stamp: 'fbs 6/15/2011 17:40'!
printOn: aStream
	^ aStream nextPutAll: 'Nothing'.! !

!Nothing methodsFor: 'accessing' stamp: 'fbs 6/14/2011 18:10'!
value
	Error signal: 'None has no value'.! !

Object subclass: #Zipper
	instanceVariableNames: 'node continuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl'!

!Zipper commentStamp: 'fbs 6/13/2011 07:47' prior: 0!
I am a suspended walk over an enumeration. That is, given a traversal strategy and a data structure, I allow for the traversal of that data structure. I also allow for copy-on-write mutation that shares structure between the old and new versions of a structure as much as my underlying enumerator allows.

In particular, my enumerator either returns false or a replacement node.!

Zipper subclass: #ZipDone
	instanceVariableNames: 'term'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl'!

!ZipDone class methodsFor: 'instance creation' stamp: 'fbs 6/14/2011 18:18'!
on: anObject
	^ self new on: anObject.! !

!ZipDone methodsFor: 'accessing' stamp: 'fbs 6/14/2011 18:15'!
term
	^ term! !

!ZipDone methodsFor: 'private' stamp: 'fbs 6/14/2011 18:15'!
term: anObject
	term := anObject.! !

!ZipDone methodsFor: 'applying' stamp: 'fbs 6/14/2011 18:39'!
zipUp
	^ term.! !

!Zipper class methodsFor: 'instance creation' stamp: 'fbs 6/14/2011 18:18'!
on: anObject with: aBinaryBlock
	^ self new on: anObject with: aBinaryBlock! !

!Zipper class methodsFor: 'as yet unclassified' stamp: 'fbs 6/17/2011 07:57'!
zipOver: aCollection
	^ [aCollection collect: [:each | | v |
			Transcript showln: 'pi'.
			v := [:k| Zipper on: each with: k] shift.
			Transcript showln: 'ng'.
			v.]] reset.! !

!Zipper class methodsFor: 'as yet unclassified' stamp: 'fbs 6/15/2011 18:03'!
zipOver: anObject using: anEnumerator
	"anObject is anything that understands #collect:."
	| f |
	f := [:k | k value: nil].
	(anObject respondsTo: #collect:) ifFalse: [^ Error signal: 'Unzippable'].
	
	^ [anObject collect: [:each | f value: each ]] reset.! !

!Zipper methodsFor: 'accessing' stamp: 'fbs 6/17/2011 07:46'!
continuation
	^ continuation.! !

!Zipper methodsFor: 'accessing' stamp: 'fbs 6/17/2011 07:46'!
node
	^ node.! !

!Zipper methodsFor: 'private' stamp: 'fbs 6/14/2011 18:19'!
on: anObject with: aBinaryBlock
	node := anObject.
	continuation := aBinaryBlock.! !

!Zipper methodsFor: 'applying' stamp: 'fbs 6/14/2011 18:46'!
zipUp
	^ continuation value: Maybe nothing.! !

TestCase subclass: #JustTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl-Tests'!

!JustTest methodsFor: 'testing - testing' stamp: 'fbs 6/15/2011 17:33'!
testIfNothingIfNotNothingRunsJustBlock
	self assert: 2 == ((Maybe value: 42) ifNothing: [1] ifNotNothing: [2])! !

!JustTest methodsFor: 'testing - running' stamp: 'fbs 6/15/2011 17:52'!
testMaybeDefaultReturnsBlockValue
	| block default result thing |
	default := Object new.
	block := [:x | x * 2].
	thing := Maybe value: 2.
	result := thing maybe: block default: default.
	self assert: result = (block value: thing value).! !

!JustTest methodsFor: 'testing - printing' stamp: 'fbs 6/15/2011 17:41'!
testPrintStringLooksLikeHaskell
	self assert: (Just value: 2) printString = 'Just 2'.! !

TestCase subclass: #MaybeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl-Tests'!

!MaybeTest methodsFor: 'testing - testing' stamp: 'fbs 6/15/2011 17:27'!
testNothingHasNoValue
	self deny: Maybe nothing hasValue.
	
	self should: [Maybe nothing value] raise: Error.! !

!MaybeTest methodsFor: 'testing - instance creation' stamp: 'fbs 6/15/2011 17:26'!
testNothingIsIdempotent
	self assert: Maybe nothing == Maybe nothing.! !

!MaybeTest methodsFor: 'testing - instance creation' stamp: 'fbs 6/15/2011 17:24'!
testValueReturnsaJust
	| r |
	r := Maybe value: 1.
	self assert: r hasValue.! !

TestCase subclass: #NothingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl-Tests'!

!NothingTest methodsFor: 'testing - testing' stamp: 'fbs 6/15/2011 17:34'!
testIfNothingIfNotNothingRunsNothingBlock
	self assert: 1 == (Maybe nothing ifNothing: [1] ifNotNothing: [2]).
	self assert: 1 == ((Nothing new) ifNothing: [1] ifNotNothing: [2]).! !

!NothingTest methodsFor: 'as yet unclassified' stamp: 'fbs 6/15/2011 17:55'!
testMaybeDefaultReturnsDefault
	| block default result |
	default := Object new.
	block := [:x | x * 2].
	result := Maybe nothing maybe: block default: default.
	self assert: result = default.! !

!NothingTest methodsFor: 'testing - printing' stamp: 'fbs 6/15/2011 17:40'!
testPrintStringLooksLikeHaskell
	self assert: Maybe nothing printString = 'Nothing'.! !
Maybe initialize!
